# -*- coding: utf-8 -*-
from ckanext.spatial.model.harvested_metadata import MappedXmlDocument, MappedXmlElement


class StatistikNordDocumentElement(MappedXmlElement):
    pass


class StatistikNordDocumentRelationship(MappedXmlElement):
    elements = [
        StatistikNordDocumentElement(
            name="Typ",
            search_paths=[
                "Typ/text()",
            ],
            multiplicity="1",
        ),
        StatistikNordDocumentElement(
            name="ID",
            search_paths=[
                "ID/text()",
            ],
            multiplicity="*",
        )
    ]


class StatistikNordDocumentResource(MappedXmlElement):
    elements = [
        StatistikNordDocumentElement(
            name="URLZumDownload",
            search_paths=[
                "URLZumDownload/text()",
            ],
            multiplicity="0..1",
        ),
        StatistikNordDocumentElement(
            name="DateinameInDerLieferung",
            search_paths=[
                "DateinameInDerLieferung/text()",
            ],
            multiplicity="0..1",
        ),
        StatistikNordDocumentElement(
            name="Ressourcenname",
            search_paths=[
                "Ressourcenname/text()",
            ],
            multiplicity="1",
        ),
        StatistikNordDocumentElement(
            name="Format",
            search_paths=[
                "Format",
            ],
            multiplicity="1",
            elements=[
                StatistikNordDocumentElement(
                    name="FormatTyp",
                    search_paths=[
                        "FormatTyp/text()",
                    ],
                    multiplicity="1"
                ),
            ]
        ),
        StatistikNordDocumentElement(
            name="Dateigroesse",
            search_paths=[
                "Dateigroesse/text()",
            ],
            multiplicity="0..1",
        )
    ]


class StatistikNordDocument(MappedXmlDocument):
    elements = [
        StatistikNordDocumentElement(
            name="Titel",
            search_paths=[
                "Titel/text()",
            ],
            multiplicity="1",
        ),
        StatistikNordDocumentElement(
            name="Beschreibung",
            search_paths=[
                "Beschreibung/text()",
            ],
            multiplicity="0..1",
        ),
        StatistikNordDocumentElement(
            name="Schlagwoerter",
            search_paths=[
                "Schlagwoerter",
            ],
            multiplicity="0..1",
            elements=[
                StatistikNordDocumentElement(
                    name="Schlagwort",
                    search_paths=[
                        "Schlagwort/text()",
                    ],
                    multiplicity="*"
                ),
            ]
        ),
        StatistikNordDocumentElement(
            name="Nutzungsbestimmungen",
            search_paths=[
                "Nutzungsbestimmungen",
            ],
            multiplicity="0..1",
            elements=[
                StatistikNordDocumentElement(
                    name="ID_derLizenz",
                    search_paths=[
                        "ID_derLizenz/text()",
                    ],
                    multiplicity="*"
                ),
            ]
        ),

        StatistikNordDocumentElement(
            name="Namensnennung",
            search_paths=[
                "Namensnennung/text()",
            ],
            multiplicity="0..1",
        ),
        StatistikNordDocumentElement(
            name="VeroeffentlichendeStelle",
            search_paths=[
                "VeroeffentlichendeStelle",
            ],
            multiplicity="1",
            elements=[
                StatistikNordDocumentElement(
                    name="Name",
                    search_paths=[
                        "Name/text()",
                    ],
                    multiplicity="1"
                ),
                StatistikNordDocumentElement(
                    name="EMailAdresse",
                    search_paths=[
                        "EMailAdresse/text()",
                    ],
                    multiplicity="0..1"
                )
            ]
        ),
        StatistikNordDocumentElement(
            name="Ansprechpartner",
            search_paths=[
                "Ansprechpartner",
            ],
            multiplicity="0..1",
            elements=[
                StatistikNordDocumentElement(
                    name="Name",
                    search_paths=[
                        "Name/text()",
                    ],
                    multiplicity="0..1"
                ),
                StatistikNordDocumentElement(
                    name="EMailAdresse",
                    search_paths=[
                        "EMailAdresse/text()",
                    ],
                    multiplicity="0..1"
                )
            ]
        ),
        StatistikNordDocumentElement(
            name="WeitereInformationen",
            search_paths=[
                "WeitereInformationen",
            ],
            multiplicity="0..1",
            elements=[
                StatistikNordDocumentElement(
                    name="URL",
                    search_paths=[
                        "URLZumDownload/text()",
                    ],
                    multiplicity="1"
                ),
            ]
        ),
        StatistikNordDocumentElement(
            name="TypDesInhalts",
            search_paths=[
                "TypDesInhalts/text()",
            ],
            multiplicity="1",
        ),

        StatistikNordDocumentElement(
            name="Ressourcen",
            search_paths=[
                "Ressourcen",
            ],
            multiplicity="1",
            elements=[
                StatistikNordDocumentResource(
                    name="Ressource",
                    search_paths=[
                        "Ressource",
                    ],
                    multiplicity="*"
                ),
            ]
        ),

        StatistikNordDocumentElement(
            name="ZeitraumVon",
            search_paths=[
                "ZeitraumVon/text()",
            ],
            multiplicity="0..1",
        ),
        StatistikNordDocumentElement(
            name="ZeitraumBis",
            search_paths=[
                "ZeitraumBis/text()",
            ],
            multiplicity="0..1",
        ),
        StatistikNordDocumentElement(
            name="ZeitlicheGranularitaetIntervallDerErhebung",
            search_paths=[
                "ZeitlicheGranularitaetIntervallDerErhebung/text()",
            ],
            multiplicity="0..1",
        ),
        StatistikNordDocumentElement(
            name="ZeitlicheGranularitaetEinheit",
            search_paths=[
                "ZeitlicheGranularitaetEinheit/text()",
            ],
            multiplicity="0..1",
        ),
        StatistikNordDocumentElement(
            name="DokumentID",
            search_paths=[
                "DokumentID/text()",
            ],
            multiplicity="1",
        ),
        StatistikNordDocumentElement(
            name="AbdeckungInKoordinatenAusOGDD",
            search_paths=[
                "AbdeckungInKoordinatenAusOGDD",
            ],
            multiplicity="0..1",
            elements=[
                StatistikNordDocumentElement(
                    name="Koordinaten",
                    search_paths=[
                        "Koordinaten/text()",
                    ],
                    multiplicity="*"
                ),
            ]
        ),
        StatistikNordDocumentElement(
            name="ArtDerFormAusOGDD",
            search_paths=[
                "ArtDerFormAusOGDD",
            ],
            multiplicity="0..1",
            elements=[
                StatistikNordDocumentElement(
                    name="Koordinaten",
                    search_paths=[
                        "Koordinaten/text()",
                    ],
                    multiplicity="*"
                ),
            ]
        ),
        StatistikNordDocumentElement(
            name="AbdeckungAlsTextAusOGDD",
            search_paths=[
                "AbdeckungAlsTextAusOGDD/text()",
            ],
            multiplicity="0..1",
        ),
        StatistikNordDocumentElement(
            name="Bild",
            search_paths=[
                "Bild/text()",
            ],
            multiplicity="0..1",
        ),
        StatistikNordDocumentElement(
            name="Infogegenstand",
            search_paths=[
                "Infogegenstand",
            ],
            multiplicity="1",
            elements=[
                StatistikNordDocumentElement(
                    name="Bezeichnung",
                    search_paths=[
                        "Bezeichnung/text()",
                    ],
                    multiplicity="*"
                ),
            ]
        ),
        StatistikNordDocumentElement(
            name="E-Aktenzeichen",
            search_paths=[
                "E-Aktenzeichen/text()",
            ],
            multiplicity="0..1",
        ),
        StatistikNordDocumentElement(
            name="Papieraktenzeichen",
            search_paths=[
                "Papieraktenzeichen/text()",
            ],
            multiplicity="0..1",
        ),
        StatistikNordDocumentElement(
            name="OfflineDatum",
            search_paths=[
                "OfflineDatum/text()",
            ],
            multiplicity="0..1",
        ),
        StatistikNordDocumentElement(
            name="Nummern",
            search_paths=[
                "Nummern",
            ],
            multiplicity="0..1",
            elements=[
                StatistikNordDocumentElement(
                    name="Nummer",
                    search_paths=[
                        "Nummer/text()",
                    ],
                    multiplicity="*"
                ),
            ]
        ),
        StatistikNordDocumentElement(
            name="Quelle",
            search_paths=[
                "Quelle/text()",
            ],
            multiplicity="1",
        ),
        StatistikNordDocumentElement(
            name="Volltext",
            search_paths=[
                "Volltext/text()",
            ],
            multiplicity="0..1",
        ),
        StatistikNordDocumentElement(
            name="AlternativtextFuerDasBild",
            search_paths=[
                "AlternativtextFuerDasBild/text()",
            ],
            multiplicity="0..1",
        ),
        StatistikNordDocumentElement(
            name="Beziehungsverknuepfungen",
            search_paths=[
                "Beziehungsverknuepfungen",
            ],
            multiplicity="0..1",
            elements=[
                StatistikNordDocumentRelationship(
                    name="Beziehungsverknuepfung",
                    search_paths=[
                        "Beziehungsverknuepfung",
                    ],
                    multiplicity="*"
                ),
            ]
        ),
        StatistikNordDocumentElement(
            name="MetadatenModellVersionsnummer",
            search_paths=[
                "MetadatenModellVersionsnummer",
            ],
            multiplicity="0..1",
            elements=[
                StatistikNordDocumentElement(
                    name="Versionsnummer",
                    search_paths=[
                        "Versionsnummer/text()",
                    ],
                    multiplicity="1"
                ),
            ]
        ),
        StatistikNordDocumentElement(
            name="StANKategorie",
            search_paths=[
                "StANKategorie/text()",
            ],
            multiplicity="1",
        ),
        StatistikNordDocumentElement(
            name="StANThemen",
            search_paths=[
                "StANThemen/StANThemaID/text()",
            ],
            multiplicity="*",

        ),
        StatistikNordDocumentElement(
            name="StANProdukte",
            search_paths=[
                "StANProdukte/StANProductID/text()",
            ],
            multiplicity="*",
        )
    ]


class StatistikNordDocuments(MappedXmlDocument):
    elements = [
        StatistikNordDocumentElement(
            name="RegistereintragsListe",
            search_paths=[
                "RegistereintragAusLiefersystem",
            ],
            multiplicity="*"
        )
    ]
